import type { PlatformApplication } from '../../base-application/types.js';
import type { ApplicationType } from '../../../lib/types/application/application.js';
/**
 * Load server configs into application.
 * all variables should be set to dest,
 * all variables should be referred from config,
 */
export declare const loadServerConfig: ({ config, application }: {
    config: any;
    application: ApplicationType;
}) => void;
/**
 * @param {Object} config - config to load config from
 * @param {import('./base-application/types.js').PlatformApplication} dest - destination context to use default is context
 */
export declare const loadPlatformConfig: ({ config, application }: {
    config: any;
    application: PlatformApplication;
}) => void;
export declare const loadDerivedServerAndPlatformProperties: ({ application }: {
    application: any;
}) => void;
/**
 * @param {import('./bootstrap-application-server/types').SpringBootApplication} dest - destination context to use default is context
 * @param {import('./base-application/types.js').PlatformApplication} dest - destination context to use default is context
 */
export declare const loadDerivedPlatformConfig: ({ application }: {
    application: PlatformApplication;
}) => void;
export declare const loadDerivedServerConfig: ({ application }: {
    application: any;
}) => void;
